BasicBrowser/BasicBrowser/urls.py
from django.conf.urls import include
from django.contrib import admin
from django.conf import settings
from django.contrib.auth import views as auth_views
from scoping import views
import BasicBrowser.views as site_views
from django.urls import include, path
from django.views.defaults import page_not_found
from django.conf import settings
from django.urls import re_path
import scoping

# handler404 = scoping.views.handler404


if settings.MAINTENANCE:
    urlpatterns = [
        re_path(r'^', scoping.views.handler404, name="maintenance"),
    ]
else:
    urlpatterns = [
        path('nacsos-legacy/', include([
            # path('lotto/', include('lotto.urls')),
            path('admin/doc/', include('django.contrib.admindocs.urls')),
            # re_path(r'^', scoping.views.handler404, name="maintenance"),
            # path('404', page_not_found, {'exception': Exception()}),
            re_path(r'^tmv_app/', include('tmv_app.urls')),
            re_path(r'^scoping/', include('scoping.urls')),
            re_path(r'^parliament/', include('parliament.urls')),
            path('twitter/', include('twitter.urls')),
            path('lotto', include('lotto.urls')),
            path('signup', site_views.signup, name='signup'),
            re_path(r'^admin/', admin.site.urls),
            re_path(r'^$', site_views.index),
            # path('accounts/', include('django.contrib.auth.urls')),
            path('accounts/password_reset', auth_views.PasswordResetView.as_view(success_url="/"),
                 name="password_reset"),
            path('accounts/password_change', auth_views.PasswordChangeView.as_view(success_url="/scoping"),
                 name="password_change"),
            path('accounts/login/', auth_views.LoginView.as_view(success_url="/"),
                 {'template_name': 'scoping/login.html'}),
            re_path(r'^accounts/logout/$', views.logout_view, name='logout_view'),
        ]))
    ]

if settings.DEBUG:
    import debug_toolbar

    urlpatterns += [
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ]

BasicBrowser/parliament/urls.py
from django.contrib.auth.decorators import login_required
from parliament import views
from django.urls import re_path
app_name = 'parliament'

urlpatterns = [

    # Homepage, Parliaments
    re_path(r'^$', views.index, name='index'),

    #Parliament pages
    re_path(r'^parliament/(?P<pid>[0-9]+)/$', views.parliament, name='parliament'),
    re_path(r'^parties/(?P<pid>[0-9]+)/$', views.parties, name='parties'),
    re_path(r'^persons/(?P<pid>[0-9]+)/$', views.persons, name='persons'),

    re_path(r'^session/(?P<pid>[0-9]+)/$', views.parlperiod, name='parlperiod'),

    re_path(r'^search/$', views.search, name='search'),
    re_path(r'^search-home/(?P<sid>[0-9]+)/$', views.search_home, name='search-home'),
    re_path(r'^search-list-results/(?P<sid>[0-9]+)/$', views.search_list_results, name='search-list-results'),

    re_path(r'^model-home/(?P<model_id>[0-9]+)/$', views.model_home, name='model-home'),

    re_path(r'^parl-topic/(?P<tid>[0-9]+)/$', views.parl_topic, name='parl-topic'),
    re_path(r'^parl-topic/(?P<tid>[0-9]+)/(?P<pid>[0-9]+)$', views.parl_topic, name='parl-topic-party'),

    re_path(r'^person/(?P<tid>[0-9]+)/$', views.person, name='person'),
    re_path(r'^party/(?P<tid>[0-9]+)/$', views.party, name='party'),

    re_path(r'^document/(?P<did>[0-9]+)/$', views.document, name='document'),
    re_path(r'^utterance/(?P<ut_id>[0-9]+)/$', views.utterance, name='utterance'),
    re_path(r'^paragraph/(?P<par_id>[0-9]+)/$', views.paragraph, name='paragraph'),

]

BasicBrowser/scoping/urls.py
from django.contrib.auth.decorators import login_required
from scoping import views
from django.urls import path, re_path

app_name = 'scoping'

urlpatterns = [


    # Homepage, projet management

    re_path(r'^$', views.index, name='index'),
    re_path(r'^project/(?P<pid>[0-9]+)/$', views.project, name='project'),



    # Query management


    #### Index pages / query set-up (user input)


    re_path(r'^queries/(?P<pid>[0-9]+)/$', views.queries, name='queries'),
    re_path(r'^query_table/(?P<pid>[0-9]+)/$', views.query_table, name='query_table'),

    path('generate_query/<int:pid>/<int:t>', views.generate_query,name="generate_query"),


    re_path(r'^docs/(?P<pid>[0-9]+)/(?P<qid>[0-9]+)$', views.doclist, name='doclist'),

    re_path(r'^create_query/(?P<pid>[0-9]+)$', views.create_query, name='create_query'),

    path('project/<int:pid>/query/add/', login_required(views.QueryCreate.as_view()),name="query_create"),
    path('duplicates/<int:pid>', views.manage_duplicates, name="manage_duplicates"),


    path('find_duplicates/<int:pid>', views.find_duplicates, name="find_duplicates"),
    path('doc_info/<int:did>/<int:did2>', views.doc_info, name="doc_info"),
    path('doc_merge/<int:pid>/<int:d1>/<int:d2>', views.doc_merge, name="doc_merge"),

    ### Paragraph stuff
    path('paragraphs/<int:qid>', views.par_manager, name="par_manager"),

    path('screen_par/<int:tid>/<int:ctype>/<int:doid>/<int:todo>/<int:done>/<int:last_doid>', views.screen_par, name="screen_par"),
    path('add_statement', views.add_statement, name="add_statement"),
    path('del_statement', views.del_statement, name="del_statement"),
    path('rate_par/<int:tid>/<int:ctype>/<int:doid>/<int:todo>/<int:done>', views.rate_par, name="rate_par"),

    ### twitter
    path('twitter-home/<int:pid>', views.twitter_home, name="twitter_home"),
    path('twitter-home/download_screened_tweets/<int:pid>', views.download_screened_tweets, name="download_screened_tweets"),


    ### Meta-analysis stuff
    path('meta-setup/<int:pid>', views.meta_setup, name="meta_setup"),
    path('meta-setup/assign_meta', views.assign_meta, name="assign_meta"),
    path('meta-setup/download_effects/<int:pid>', views.download_effects, name="download_effects"),
    path('meta-setup/report/<int:pid>', views.meta_report, name="meta_report"),
    path('code-document/<int:docmetaid>',views.code_document,name='code_document'),
    path('code-document/<int:docmetaid>/<int:reorder>',views.code_document,name='code_document'),
    path('exclude-document/<int:dmc>',views.ExcludeView.as_view(), name="exclude"),
    path('save-document-code/<int:docmetaid>/<int:dest>',views.save_document_code,name='save_document_code'),
    path('add-effect/<int:docmetaid>',views.add_effect,name='add_effect'),
    path('add-effect/<int:docmetaid>/<int:eff_copy>',views.add_effect,name='add_effect'),
    path('add-effect/<int:docmetaid>/<int:eff_copy>/<int:eff_edit>',views.add_effect,name='add_effect'),
    path('add-intervention/<int:effectid>',views.add_intervention,name='add_intervention'),
    path('add-intervention/<int:effectid>/<int:iid>',views.add_intervention,name='add_intervention'),
    path('add-intervention/<int:effectid>/<int:iid>/<int:i_edit>',views.add_intervention,name='add_intervention'),
    path('download-calculations/<int:id>', views.download_calculations, name="download_calculations"),


    path('db1-db2-report/<int:tagid>', views.db1_db2_report, name="db1_db2_report"),
    path('tag-comparison/<int:tagid>', views.tag_comparison, name="tag_comparison"),

    path('risk-of-bias/<int:dmcid>', login_required(views.RoBCreate.as_view()),name="rob_create"),
    path('edit-risk-of-bias/<int:dmcid>', login_required(views.RoBEdit.as_view()),name="rob_edit"),

    re_path(r'^snowball$', views.snowball, name='snowball'),
    #### Query processing
    re_path(r'^start_snowballing$', views.start_snowballing, name='start_snowballing'),
    re_path(r'^do_snowballing/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)$', views.do_snowballing, name='do_snowballing'),
    re_path(r'^dodocadd/(?P<qid>[0-9]+)$', views.dodocadd, name='dodocadd'),
    re_path(r'^querying/(?P<qid>[0-9]+)/(?P<substep>[0-9]+)/(?P<docadded>[0-9]+)/(?P<q2id>[0-9]+)$', views.querying, name='querying'),
    re_path(r'^querying/(?P<qid>[0-9]+)/(?P<substep>[0-9]+)/(?P<docadded>[0-9]+)/$', views.querying, name='querying'),
    re_path(r'^querying/(?P<qid>[0-9]+)/$', views.querying, name='querying'),
    re_path(r'^snowball_progress/(?P<sbs>[0-9]+)/$', views.snowball_progress, name='snowball_progress'),

    #### Manage Query
    re_path(r'^query/(?P<qid>[0-9]+)/$', views.query, name='query'),
    path('query_dev/<int:qid>/', views.query_dev, name='query_dev'),
    re_path(r'^query-tm-manager/(?P<qid>[0-9]+)/$', views.query_tm_manager, name='query_tm_manager'),
    re_path(r'^query-tm/(?P<qid>[0-9]+)/$', views.query_tm, name='query_tm'),
    re_path(r'^run_model-tm/(?P<run_id>[0-9]+)/$', views.run_model, name='run_model'),

    ### Topic model checking
    path('word_intrusion/<int:run_id>', views.word_intrusion, name="word_intrusion"),
    path('proc_word_intrusion/<int:wid>/<int:tid>', views.proc_word_intrusion, name="proc_word_intrusion"),

    path('topic_intrusion/<int:run_id>', views.topic_intrusion, name="topic_intrusion"),
    path('proc_topic_intrusion/<int:tid>/<int:top_id>', views.proc_topic_intrusion, name="proc_topic_intrusion"),

    #### Manage SBS
    re_path(r'^sbs_allocateDocsToUser/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)$', views.sbs_allocateDocsToUser, name='sbs_allocateDocsToUser'),
    re_path(r'^sbs_setAllQDocsToIrrelevant/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)/(?P<sbsid>[0-9]+)$', views.sbs_setAllQDocsToIrrelevant, name='sbs_setAllQDocsToIrrelevant'),
    re_path(r'^sbsKeepDoc/(?P<qid>[0-9]+)/(?P<did>.+)$', views.sbsKeepDoc, name='sbsKeepDoc'),
    re_path(r'^sbsExcludeDoc/(?P<qid>[0-9]+)/(?P<did>.+)$', views.sbsExcludeDoc, name='sbsExcludeDoc'),
    re_path(r'^delete_query/(?P<qid>[0-9]+)$', views.delete_query, name='delete'),
    re_path(r'^delete_sbs/(?P<sbsid>[0-9]+)$', views.delete_sbs, name='delete'),

    #### Others
    ## Cities
    re_path(r'^cities/(?P<qid>[0-9]+)$',views.cities, name='cities'),
    re_path(r'^city_data/(?P<qid>[0-9]+)$',views.city_data, name='city_data'),
    re_path(r'^city_docs/(?P<qid>[0-9]+)$',views.city_docs, name='city_docs'),

    re_path(r'^switchmode$', views.switch_mode, name='switch_mode'),

    re_path(r'^categories/(?P<pid>[0-9]+)',views.categories, name='categories'),
    path('filter_categories/<int:pid>/<int:level>', views.filter_categories, name="filter_categories"),
    re_path(r'^category/(?P<tid>[0-9]+)$',views.category, name='category'),
    re_path(r'^download_tdocs/(?P<tid>[0-9]+)$',views.download_tdocs, name='download_tdocs'),
    re_path(r'^authorlist/(?P<tid>[0-9]+)$',views.prepare_authorlist, name='authorlist'),
    re_path(r'^sendauthorlist/(?P<tid>[0-9]+)$',views.send_authorlist, name='send_authorlist'),

    re_path(r'^textplace-autocomplete/$',views.TextPlaceAutocomplete.as_view(create_field='name'),name="textplace-autocomplete"),
    path(r'textfree-autocomplete/',views.TextFreeAutocomplete.as_view(create_field='name'),name="textfree-autocomplete"),
    re_path(r'^country-autocomplete/$',views.CountryAutocomplete.as_view(create_field='name'),name="country-autocomplete"),

    path('duc_country', views.duc_country, name='duc_country'),
    path('duc_place', views.duc_place, name='duc_place'),
    path('duc_text', views.duc_text, name='duc_text'),
    path('duc_year', views.duc_year, name='duc_year'),
    path('duc_number', views.duc_number, name='duc_number'),

    re_path(r'^add_othercat',views.add_othercat, name='add_othercat'),
    re_path(r'^del_othercat',views.del_othercat, name='del_othercat'),

    re_path(r'^add_tech',views.add_tech, name='add_tech'),
    re_path(r'^async_add_tech',views.async_add_tech, name='async_add_tech'),
    path('update_tech/<int:tid>',views.update_tech, name='update_tech'),

    re_path(r'^user/(?P<pid>[0-9]+)$', views.userpage, name='userpage'),

    re_path(r'^update_criteria$', views.update_criteria, name='update_criteria'),

    re_path(r'^docs/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)/(?P<sbsid>[0-9]+)$', views.doclist, name='doclistsbs'),

    re_path(r'^docssbs/(?P<sbsid>[0-9]+)$', views.doclistsbs, name='doclistsbs'),
    re_path(r'^docrellist/(?P<sbsid>[0-9]+)/(?P<qid>[0-9]+)/(?P<q2id>[0-9]+)/(?P<q3id>[0-9]+)$', views.docrellist, name='docrellist'),
    re_path(r'^sort_docs$', views.sortdocs, name='sortdocs'),
    path('export-docs/<int:qid>/',views.export_ris_docs,name='export-docs'),

    re_path(r'^cycle_score$', views.cycle_score, name='cycle_score'),
    re_path(r'^activate_user$', views.activate_user, name='activate_user'),
    re_path(r'^assign_docs$', views.assign_docs, name='assign_docs'),
    re_path(r'^remove_assignments$', views.remove_assignments, name='remove_assignments'),


    #### Individual docs
    re_path(r'^screen/(?P<tid>[0-9]+)/(?P<ctype>[0-9]+)/(?P<d>[-0-9]+)$', views.screen, name='screen'),
    re_path(r'^do_review$', views.do_review, name='do_review'),
    re_path(r'^add_note', views.add_note, name='add_note'),

    path('screen_doc/<int:doid>', views.screen_doc_id, name='screen_doc_id'),
    path('screen_doc/<int:tid>/<int:ctype>/<int:pos>/<int:todo>', views.screen_doc, name='screen_doc'),
    path('screen_doc/<int:tid>/<int:ctype>/<int:pos>/<int:todo>/<int:js>', views.screen_doc, name='screen_doc'),

    path('rate_doc/<int:tid>/<int:ctype>/<int:doid>/<int:pos>/<int:todo>/<int:rel>', views.rate_doc, name='rate_doc'),
    path('cat_doc/', views.cat_doc, name='cat_doc'),

    # Nice function for updateing many things
    re_path(r'^update_thing',views.update_thing, name='update_thing'),


    re_path(r'^download/(?P<qid>[0-9]+)', views.download, name='download'),
    re_path(r'^download_pdf/(?P<id>[0-9]+)', views.download_pdf, name='download_pdf'),

BasicBrowser/tmv_app/urls.py
from django.conf.urls import include
from django.conf import settings
from django.conf.urls.static import static
from django.urls import path, re_path

from tmv_app.views import *
from django.contrib.auth.decorators import login_required

app_name = 'tmv_app'

urlpatterns = [
    re_path(r'^$', login_required(runs), name='index'),
    path('network/<int:run_id>', login_required(network), name='network'),
    path('network/<int:run_id>/<str:csvtype>', login_required(network), name='network'),
    re_path(r'^network_wg/(?P<run_id>\d+)$', login_required(network_wg), name='network_wg'),
    re_path(r'^network_wg/(?P<run_id>\d+)/(?P<t>\d+)/(?P<f>\d+)/(?P<top>.+)$', login_required(network_wg), name='network_wg'),
    re_path(r'^return_corrs$', login_required(return_corrs), name='return_corrs'),
    re_path(r'^growth/(?P<run_id>\d+)$', login_required(growth_heatmap), name='growth_heatmap'),
    re_path(r'^growth_json/(?P<run_id>\d+)/(?P<v>.+)/$', login_required(growth_json), name='growth_json'),

    # topic page and topic doc loader
    re_path(r'^topic/(?P<topic_id>\d+)/$', login_required(topic_detail), name="topic_detail"),
    re_path(r'^topic/(?P<topic_id>\d+)/(?P<run_id>\d+)/$', login_required(topic_detail), name="topic_detail"),
    re_path(r'^get_topic_docs/(?P<topic_id>\d+)/$', login_required(get_topic_docs), name="get_topic_docs"),
    path('get_topicterms/<int:topic_id>', login_required(get_topicterms), name="get_topicterms"),
    re_path(r'^multi_topic/$', login_required(multi_topic), name="multi_topic"),

    re_path(r'^highlight_dtm_w$', login_required(highlight_dtm_w), name="highlight_dtm_w"),
    re_path(r'^dynamic_topic/(?P<topic_id>\d+)/$', login_required(dynamic_topic_detail), name="dynamic_topic_detail"),

    re_path(r'^term/(?P<run_id>\d+)/(?P<term_id>\d+)/$', login_required(term_detail), name="term_detail"),
    re_path(r'^doc/random/(?P<run_id>\d+)$', login_required(doc_random), name="random_doc"),
    re_path(r'^doc/(?P<doc_id>.+)/(?P<run_id>\d+)$', login_required(doc_detail), name="doc_detail"),
    re_path(r'^author/(?P<author_name>.+)/(?P<run_id>\d+)$', login_required(author_detail), name="author_detail"),
    re_path(r'^institution/(?P<run_id>\d+)/(?P<institution_name>.+)/$', login_required(institution_detail)),
    # Home page
    re_path(r'^topic_presence/(?P<run_id>\d+)$', login_required(topic_presence_detail),name="topics"),

    re_path(r'^topics_time/(?P<run_id>\d+)/(?P<stype>\d+)$', login_required(topics_time),name="topics_time"),
    re_path(r'^topics_time_csv/(?P<run_id>\d+)/$', login_required(get_yt_csv),name="topics_time_csv"),
    re_path(r'^stats/(?P<run_id>\d+)$', login_required(stats), name="stats"),

    re_path(r'^runs$', login_required(runs), name='runs'),
    re_path(r'^runs/(?P<pid>\d+)/$', login_required(runs), name='runs'),

    re_path(r'^adjust_threshold/(?P<run_id>\d+)/(?P<what>.+)$', login_required(adjust_threshold), name='adjust_threshold'),

    re_path(r'^update/(?P<run_id>\d+)$', login_required(update_run), name='update'),
    re_path(r'^runs/delete/(?P<new_run_id>\d+)$', login_required(delete_run), name='delete_run'),

    re_path(r'^topic/random$', login_required(topic_random)),
    re_path(r'^term/random$', login_required(term_random)),
    re_path(r'^print_table/(?P<run_id>\d+)$', login_required(print_table), name="print_table"),

    re_path(r'^compare/(?P<a>\d+)/(?P<z>\d+)$', login_required(compare_runs), name="compare_runs")

    ]


    # Example:
    # (r'^BasicBrowser/', include('BasicBrowser.foo.urls')),

    # Uncomment the admin/doc line below to enable admin documentation:
    # (r'^admin/doc/', include('django.contrib.admindocs.urls')),

    # Uncomment the next line to enable the admin:
    # (r'^admin/', include(admin.site.urls)),



#onyl serve static content for development
#urlpatterns += static(settings.STATIC_URL,document_root='static')

BasicBrowser/scoping/templates/scoping/base.html
<html>
<head>
{% load static %}
<link href="{% static 'scoping/css/styling.css' %}" rel="stylesheet" type="text/css">
{% load scoping_extras %}
{% load render_table from django_tables2 %}
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>Scoping</title>

<script src="{% static 'scoping/js/d3.v3.min.js' %}"></script>
<script src="{% static 'scoping/js/jquery-3.2.0.min.js' %}"></script>
<script src="{% static 'scoping/js/jquery.text-select.js' %}"></script>
<script src="https://d3js.org/d3.v4.min.js"></script>

</head>
  <body>
      {% include 'scoping/nav_bar.html' with user=user qid=query.id query=query qid=query.id %}


<div id="main">
<div id="graph">
    {% block content %} {% endblock %}
    </div>
    </div>

    </body>
    {% block script %} {% endblock %}
</html>

BasicBrowser/scoping/templates/scoping/categories.html
{% extends "scoping/base_bs.html" %}
{% load bootstrap4 %}

{% block content %}
<h1> Scoping Review Helper</h1>
<br>

<!-- Query manager -->
<h2> Category Manager </h2>
<br>


<table class="table">

		<tr class="title">
			<td>ID</td>
            <td>Title</td>
            <td>Level</td>
			<td>Description</td>
            <td>Parent Category</td>
			<td>Queries</td>
			<td>Documents</td>
            <td>Update</td>
            <td>Delete</td>
        </tr>
		{% for t in techs %}
            <tr>
                <form action="" method="post"
                class="form-inline">
                  {% csrf_token %}
                  <!-- {% bootstrap_form t.form layout='inline' %} -->
                  <td><a href="{% url 'scoping:category' t.id %}">{{ t.id }}</a></td>

                  {% for field in t.form %}
                  <td>{{field}}
                  {% endfor %}

			    <td>{{ t.queries }}</td>
			    <td>{{ t.docs }}</td>

                <td>
                {% bootstrap_button 'Update' %}
                </td>
                </form>
                <td><a href="{% url 'scoping:delete' 'Category' t.id %}"><button class="btn" onclick="return confirm('Are you sure you would like to delete this technology?');">Delete</button></a></td>
		    </tr>

		{% endfor %}

</table>

<br/><hr/><br/>


<h2> Add Category </h2>
<br/>
<form action="" method="post" class="form form-horizontal">
    {% csrf_token %}
    {% bootstrap_form form layout='horizontal' %}
    {% bootstrap_button 'Save' %}
</form>
</div>
</div>
</body>

{% endblock %}


{% block script %}
<script type="text/javascript">

$('*[id*="level"]').change(function() {
    var pref = $(this).attr('id').split(/[_-]/)[1]
    changeLevel(pref,$(this).val())
})

function changeLevel(pref,val) {
    var sel = $('#id_'+pref+'-parent_category')
    var row = sel.parent().parent()
    if (val>1) {
        row.removeClass("hidden")
        selected = sel.val()
        console.log(selected)
        sel.html('')
        var pid = {{project.id}}
        var l = val-1
	var url = `{% url "scoping:filter_categories" project.id 0 %}`
	url = url.replace('0',l)
	console.log(url)
        var opt = new Option("---------", "")
        $(opt).html("---------");
        sel.append(opt)
        $.ajax({
            url: url,
            success: function(data) {
                data.forEach(function(o){
                    var opt = new Option(o.name, o.id)
                    $(opt).html(o.name);
                    sel.append(opt)
                });
                sel.val(String(selected))
            }
        })
    } else {
        sel.attr("required",false)
        sel.html('')
        var opt = new Option("---------", "")
        $(opt).html("---------");
        sel.append(opt)
        if (pref=="add") {
            row.addClass("hidden")
        }
    }
}


</script>

{% endblock %}

</html>

BasicBrowser/scoping/templates/scoping/city_docs.html
{% load static %}
<script src="{% static 'tmv_app/js/pie.js' %}"></script>
<link href="{% static 'tmv_app/css/styling.css' %}" rel="stylesheet" type="text/css">

<h2>{{city.name}}: {{ndocs}} documents</h2>

<table >
<tr><td><canvas id="canvas" width="200" height="200"></canvas></td></tr>
<tr class="title">
    <td>related topics</td>
</tr>

{% for topic in topics %}
  <tr class="list">
    <td id="topic_{{ topic.topic }}" onmouseover="highlight({{ forloop.counter|add:"-1" }})">
      <span class="{{ topic.ntopic }}">{{ topic.topic__title }}</span>
    </td>
  </tr>
{% endfor %}

</table>
</td>

{% for d in docs %}
<p>
{{d.title}} [<a href="{% url 'scoping:document' project.id d.pk %}">Link</a>]

{% endfor %}


<script type="text/javascript">

var array = {{ pie_array|safe }};
var elements = generate_pie_elements(array);
var piec = null;
function init() {
    // create pie chart
    piec = new PieChart(elements);
    piec.initialize();
}

function highlight(i) {
    piec.highlight(i);
}

function unhighlight() {
    piec.unhighlight();
}
console.log(array)
for (t=0;t < array.length;t++) {
    console.log(t)
}
init()

</script>

BasicBrowser/scoping/templates/scoping/nav_bar.html
<div id="navigation">

  <table>
    <tr>
        {% if request.session.appmode == 'snowballing' %}
          <td class="linked"><a href="/nacsos-legacy/scoping/snowball">Start snowballing</a></td>
          <td class="linked"><a href="/nacsos-legacy/scoping/user">My snowballing sessions</a></td>
          <td class="linked"><a href="/nacsos-legacy/scoping/docs/{{qid}}">Select documents</a></td>
          <td class="linked"><a href="/nacsos-legacy/scoping/docssbs/{{sbsid}}">See all documents</a></td>
          <td></td>
          <td><a href="/nacsos-legacy/scoping/switchmode"><div style="color:#4d00ee;"><b><i>&gt; Switch to Scoping mode &lt;</i></b></div></a></td>

          {% else %}
          <td class="linked"><a href="{% url 'scoping:index' %}">Home</a></td>
          {% if project %}
              <td class="linked"><a href="{% url 'scoping:categories' project.id %}">Categories</a></td>
              <td class="linked"><a href="{% url 'scoping:queries' project.id %}">Queries</a></td>
              <td class="linked"><a href="{% url 'scoping:userpage' project.id %}">{{user}}</a></td>
              {% if qid %}
                  <td class="linked"><a href="{% url 'scoping:doclist' project.id qid %}">Documents</a></td>
              {% endif %}
              <td class="linked"><a href="{% url 'scoping:manual_add_doc_form' project.id %}">Add Reference Manually</a></td>
          {% endif %}

          <td></td>
          <!-- <td><a href="/scoping/switchmode"><div style="color:#ee4d00;"><b><i>&gt; Switch to Snowballing mode &lt;</i></b></div></a></td> -->


        {% endif %}
    </tr>
  </table>
</div>

BasicBrowser/scoping/templates/scoping/nav_bar_bs.html
<nav class="navbar navbar-expand-lg navbar-light bg-white border">

    <a class="navbar-brand" href="#"></a>
  <button class="navbar-toggler" type="button" data-toggle="collapse" data-target="#navbarSupportedContent" aria-controls="navbarSupportedContent" aria-expanded="false" aria-label="Toggle navigation">
    <span class="navbar-toggler-icon"></span>
  </button>

     <div class="collapse navbar-collapse" id="navbarSupportedContent">
       <ul class="navbar-nav mr-auto">
         <li class="nav-item active">
           <a class="nav-link" href="{% url 'scoping:index' %}">Projects <span class="sr-only">(Projects)</span></a>
         </li>
         {% if project %}
         <li class="nav-item">
           <a class="nav-link" href="{% url 'scoping:project' project.id %}">Home <span class="sr-only">(Home)</span></a>
         </li>
         <li class="nav-item">
           <a class="nav-link" href="{% url 'scoping:categories' project.id %}">Categories</a>
         </li>
         {% if project.criteria == None %}
         <li class="nav-item">
           <a class="nav-link" href="{% url 'scoping:queries' project.id %}">Queries</a>
         </li>
         {% endif %}
         <li class="nav-item">
           <a class="nav-link" href="{% url 'scoping:userpage' project.id %}">{{user}}</a>
         </li>
         {% if qid %}
             <li class="nav-item"><a class="nav-link" href="{% url 'scoping:doclist' project.id qid %}">Documents</a></li>
         {% endif %}
         {% if project.criteria == None %}
         <li class="nav-item"><a class="nav-link" href="{% url 'scoping:manual_add_doc_form' project.id %}">Add Reference Manually</a></li>
         {% endif %}
         <!-- <li class="nav-item">
           <a class="nav-link" href="#">Link</a>
         </li> -->
         {% endif %}
     </div>
</nav>